# XXX note: build fails with jikes-1.22-1 so it should not be installed when
# building this package

%define ox_ver 0.8.0
%define ox_rel 4

%define with_ssl %{?_with_ssl:1}%{!?_with_ssl:0}

%define _logdir %{_var}/log

Name: open-xchange
Version: %{ox_ver}.%{ox_rel}
Release: 1

Summary: OPEN-XCHANGE - The Collaboration and Integration Environment
License: GPL
Group: Applications/Internet
URL: http://mirror.open-xchange.org/ox/EN/community/download.htm

Source: %name-%ox_ver-%ox_rel.tar.bz2
Source1: %name-apache.conf
#Source2: %name.init
Source20: %name-groupware.init
Source21: %name-sessiond.init
Source22: %name-webmail.init
Source3: openexchange-groupware.in
Source4: openexchange-sessiond.in
Source5: openexchange-webmail.in
Source6: %name-servlet.xml
Source7: ox_zenith_iconset-0.1.tar.gz
Source8: %name-umin.xml
Source9: %name-tomcat4-servlet.xml
Source10: %name-tomcat4-umin.xml
Source11: %name-QUICK-START
# RU translation. Translated by Alex <exilit at nm.ru>
Source12: ott_groupware_%ox_ver-3.tar.bz2
Source13: ott_webmail_%ox_ver-3.tar.bz2
Patch: %name-Makefile.patch
Patch1: %name-fix-perl.patch
Patch2: %name-init_ldap.patch
Patch3: %name-oxumin.patch
BuildRoot: %{_tmppath}/%{name}-root
Requires: java
BuildPreReq: /proc java-devel openldap-clients

%define pgjdbc %_javadir/postgresql.jar

%if %{with_ssl}
BuildArch: noarch
%endif

BuildRequires: ant bcel jaf jai jakarta-commons-logging jakarta-commons-net oro
BuildRequires: regexp javamail jdepend jdom jsch junit log4j servletapi5 xalan-j2 xerces-j2
BuildRequires: xml-commons-apis sudo gcc-c++
BuildRequires: postgresql-jdbc >= 8.0
#XXXBuildRequires: stylebook
BuildRequires: sed

%description
OPEN-XCHANGE is a collaboration and integration server environment
with a continuous right management for modules and objects.
The product is based on existing components like a web server,
mail server, directory server, database ...

There are several interfaces (like WebDAV/XML interfaces)
coming along with this software.

OPEN-XCHANGE provides the following modules:
 - portal
 - calendar
 - contacts
 - addresses
 - tasks
 - projects
 - documents
 - knowledge
 - bookmarks
 - pinbord
 - forums
 - webmailer

OPEN-XCHANGE is JAVA(tm) based with some pieces of C for security
components.

%package server
Group: System Environment/Daemons
Summary: OPEN-XCHANGE server
Requires: %name = %version
Requires: openldap-servers openldap-clients postgresql-jdbc
Requires: perl perl-IO-Socket-SSL perl-Net-SSLeay perl-URI
AutoReq: yes, noperl

%description server
%name server.

%package javadoc
Group: Development/Languages
Summary: Javadoc for %name
Requires: java

%description javadoc
Javadoc for %name.

%package webapp-tomcat4
Group: Applications/Internet
Summary: OPEN-XCHANGE webapp for tomcat4
Requires: tomcat4
Requires: %name-server = %version

%description webapp-tomcat4
%summary

%package webapp-tomcat5
Group: Applications/Internet
Summary: OPEN-XCHANGE webapp for tomcat5
Requires: tomcat5
Requires: %name-server = %version

%description webapp-tomcat5
%summary

%package apache
Group: Applications/Internet
Summary: OPEN-XCHANGE configuration file for apache 1.3
Requires: apache mod_jk
Requires: %name-server = %version

%description apache
%summary

%package apache2
Group: Applications/Internet
Summary: OPEN-XCHANGE configuration file for apache 2.x
Requires: httpd mod_jk-ap20
Requires: %name-server = %version

%description apache2
%summary

%prep
%setup -q -n %name-%ox_ver-%ox_rel
%patch -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0

# fixed in 8.0
#%__subst "s|cp -c src/misc/ssl/liboxssl.la |cp src/misc/ssl/liboxssl.la \${DESTDIR}|" Makefile.in
# move tmpdir in a safe place
#%__subst "s|temporary_ldap_scripts.ldif|tmp/temporary_ldap_scripts.ldif|" conf/admintools.conf.in
%{__sed} -i -e 's|temporary_ldap_scripts.ldif|tmp/temporary_ldap_scripts.ldif|' conf/admintools.conf.in
#%__subst "s|/tmp/|%_localstatedir/%name/tmp/|" conf/groupware/server.conf.in conf/webmail/server.conf.in
for file in conf/groupware/server.conf.in conf/webmail/server.conf.in ; do
	%{__sed} -i -e 's|/tmp/|%_localstatedir/%name/tmp/|' $file
done
# replace webpath /cgi-bin/ by /ox/
#%__subst "s|/cgi-bin/|/ox/|" groupware/DE/logout.htm groupware/EN/logout.htm templates/groupware/html/logout.htm
for file in groupware/DE/logout.htm groupware/EN/logout.htm templates/groupware/html/logout.htm ; do
	%{__sed} -i -e 's|/cgi-bin/|/ox/|' $file
done

%__cp -f %SOURCE3 bin/groupware/
%__cp -f %SOURCE4 bin/groupware/
%__cp -f %SOURCE5 bin/webmail/
%__cp %SOURCE11 ./QUICK-START.ALT
for file in bin/groupware/openexchange-groupware.in bin/groupware/openexchange-sessiond.in bin/webmail/openexchange-webmail.in
do
	#%__subst "s|@@LOGDIR@@|%_logdir/%name|" $file
	#%__subst "s|@@PIDDIR@@|%_var/run/%name|" $file
	#%__subst "s|@@LIBDIR@@|%_libdir/%name|" $file
	#%__subst "s|@@MJ@@|%_javadir/javamail/mailapi.jar:%_javadir/javamail/pop3.jar:%_javadir/javamail/smtp.jar|" $file
	%{__sed} -i -e 's|@@LOGDIR@@|%_logdir/%name|' $file
	%{__sed} -i -e 's|@@PIDDIR@@|%_var/run/%name|' $file
	%{__sed} -i -e 's|@@LIBDIR@@|%_libdir/%name|' $file
	%{__sed} -i -e 's|@@MJ@@|%_javadir/javamail/mailapi.jar:%_javadir/javamail/pop3.jar:%_javadir/javamail/smtp.jar|' $file
done

%__tar xzf %SOURCE7

%__cp -f ox_zenith_iconset/top/* system/www/groupware/images/top/EN
%__cp -f ox_zenith_iconset/top/* system/www/groupware/images/top/DE

# XXX to fix compilation with jikes 1.22
##perl -pi -e 's|debug="on" optimize="off"|debug="on" optimize="off" nowarn="on"|' build.xml.in
#perl -pi -e 's|</javac>|<compilerarg value="-Xlint:-all" /></javac>|' build.xml.in
%{__sed} -i -e 's|</javac>|<compilerarg value="-Werror" /></javac>|' build.xml.in
%{__sed} -i -e 's|<pathelement location="\@mailjar\@"/>|<pathelement location="\@mailjar\@"/><pathelement location="%_javadir/javamail/mailapi.jar"/>|' build.xml.in

%build
./configure \
	--prefix=%_usr \
	--datadir=%_datadir/%name \
	--sysconfdir=%_sysconfdir/%name \
	--localstatedir=%_localstatedir/%name/ \
	--libdir=%_javadir/%name \
	--with-mailjar=%_javadir/javamail/imap.jar \
	--with-activationjar=%_javadir/activation.jar \
	--with-jdomjar=%_javadir/jdom.jar \
	--with-jsdkjar=%_javadir/servletapi5.jar \
	--with-jdbcjar=%pgjdbc \
	--with-htdocsdir=%_datadir/%name/htdocs \
	--with-cgibindir=%_datadir/%name/cgi-bin \
%if %{with_ssl}
	--enable-ssl \
%endif
	--enable-webdav \
	--enable-doc \
	--with-runuid=ox \
	--with-rungid=ox

make %{?_smp_mflags}

%install
rm -rf %{buildroot}

make DESTDIR=%{buildroot} install
%__rm -rf %{buildroot}/%_sysconfdir/%name/init.d
%__rm -f %{buildroot}/%_sysconfdir/%name/initscript.conf
%__mv %{buildroot}/%_bindir/* %{buildroot}/%_sbindir/

%__mkdir_p %{buildroot}%_sysconfdir/{httpd/conf,httpd/conf.d}
%__mkdir_p %{buildroot}%_sysconfdir/rc.d/init.d
%__mkdir_p %{buildroot}%_logdir/%name
%__mkdir_p %{buildroot}%_javadocdir/%name
%__mkdir_p %{buildroot}%_var/run/%name
%__mkdir_p %{buildroot}%_localstatedir/%name/tmp
%__cp -pR %SOURCE1 %{buildroot}%_sysconfdir/httpd/conf/%name.conf
%__cp -pR %SOURCE1 %{buildroot}%_sysconfdir/httpd/conf.d/A.%name.conf
#%__cp -pR %SOURCE2 %{buildroot}%_sysconfdir/rc.d/init.d/%name
%__cp -pR %SOURCE20 %{buildroot}%_sysconfdir/rc.d/init.d/%name-groupware
%__cp -pR %SOURCE21 %{buildroot}%_sysconfdir/rc.d/init.d/%name-sessiond
%__cp -pR %SOURCE22 %{buildroot}%_sysconfdir/rc.d/init.d/%name-webmail

##%__subst "s|@@OX_USER@@|ox|" %{buildroot}%_sysconfdir/rc.d/init.d/%name
##%__subst "s|@@PIDDIR@@|%_var/run/%name|" %{buildroot}%_sysconfdir/rc.d/init.d/%name
#%{__sed} -i -e "s|@@OX_USER@@|ox|" %{buildroot}%_sysconfdir/rc.d/init.d/%name
#%{__sed} -i -e "s|@@PIDDIR@@|%_var/run/%name|" %{buildroot}%_sysconfdir/rc.d/init.d/%name

%__mv %{buildroot}/%_localstatedir/%name/log/* %{buildroot}/%_logdir/%name
%__rm -rf %{buildroot}%_localstatedir/%name/log
%__ln_s %_logdir/%name %{buildroot}%_localstatedir/%name/log
%__mv %{buildroot}%_usr/info/java/* %{buildroot}%_javadocdir/%name

# make links to open-xchange jars and classes for tomcat5
%__mkdir_p %{buildroot}%_var/lib/tomcat5/webapps/servlet/WEB-INF/{classes,lib}
for jar in comfiretools intranet nas sessiond webmail webdav umin
do
	%__ln_s %_javadir/%name/$jar.jar %{buildroot}%_var/lib/tomcat5/webapps/servlet/WEB-INF/lib/
done
%__ln_s %pgjdbc %{buildroot}%_var/lib/tomcat5/webapps/servlet/WEB-INF/lib/

for class in intranet webmail
do
	%__ln_s %_datadir/%name/servlets/$class.class %{buildroot}%_var/lib/tomcat5/webapps/servlet/WEB-INF/classes/
done

%__mkdir_p %{buildroot}%_var/lib/tomcat5/webapps/umin
%__mv %{buildroot}%_javadir/%name/umin.war %{buildroot}%_var/lib/tomcat5/webapps/umin
cd %{buildroot}%_var/lib/tomcat5/webapps/umin
jar -xf umin.war
%__mkdir_p %{buildroot}%_datadir/%name/{htdocs/cfintranet/umin/,umin/data}
%__mv web/css web/images web/javascript %{buildroot}%_datadir/%name/htdocs/cfintranet/umin/
%__mv web/templates %{buildroot}%_datadir/%name/umin/data/
%__rm -rf web
%__ln_s %_datadir/%name/umin/data %{buildroot}%_var/lib/tomcat5/webapps/umin/web
%__mkdir_p %{buildroot}%_sysconfdir/%name/umin
%__mv etc/* %{buildroot}%_sysconfdir/%name/umin
%__rm -rf etc
%__rm -f WEB-INF/lib/*
%__mv WEB-INF/classes/* %{buildroot}%_sysconfdir/%name/umin
for properties in oxusermin oxusermin_de oxusermin_en oxuserminconfig
do
	%__ln_s %_sysconfdir/%name/umin/$properties.properties %{buildroot}%_var/lib/tomcat5/webapps/umin/WEB-INF/classes/
done

for jar in comfiretools nas umin
do
	%__ln_s %_javadir/%name/$jar.jar %{buildroot}%_var/lib/tomcat5/webapps/umin/WEB-INF/lib/
done
%__ln_s %pgjdbc %{buildroot}%_var/lib/tomcat5/webapps/umin/WEB-INF/lib/

%__rm -f umin.war
%__rm -f %{buildroot}%_javadir/%name/servlet.war

cd $RPM_BUILD_DIR/%name-%ox_ver-%ox_rel

# install open-xchange's xml conf file for tomcat5
%__mkdir_p %{buildroot}%_sysconfdir/tomcat5/Catalina/localhost
%__cp %SOURCE6 %{buildroot}%_sysconfdir/tomcat5/Catalina/localhost/
%__cp %SOURCE8 %{buildroot}%_sysconfdir/tomcat5/Catalina/localhost/

# tomcat4. Just copy from tomcat5
%__mkdir_p %{buildroot}%_var/lib/tomcat4/webapps
%__cp -pR %{buildroot}%_var/lib/tomcat5/webapps/* %{buildroot}%_var/lib/tomcat4/webapps/
%__cp %SOURCE9 %{buildroot}%_var/lib/tomcat4/webapps/%name-servlet.xml
%__cp %SOURCE10 %{buildroot}%_var/lib/tomcat4/webapps/%name-umin.xml

# make 2 links to ldap.conf
%__ln_s %_sysconfdir/openldap/ldap.conf %{buildroot}%_sysconfdir/%name/groupware/
%__ln_s %_sysconfdir/openldap/ldap.conf %{buildroot}%_sysconfdir/%name/webmail/

%__install -m 644 system/servlet/web.xml %{buildroot}%_var/lib/tomcat5/webapps/servlet/WEB-INF/

%if %{with_ssl}
%__mkdir_p %{buildroot}%_libdir/%name
%__mv %{buildroot}%_javadir/%name/liboxssl.so.1.0.0 %{buildroot}/%_libdir/%name
%__rm -f %{buildroot}%_javadir/%name/liboxssl.so*
%__ln_s liboxssl.so.1.0.0 %{buildroot}%_libdir/%name/liboxssl.so
%__ln_s liboxssl.so.1.0.0 %{buildroot}%_libdir/%name/liboxssl.so.1
%endif

# RU locale
%__tar xjf %SOURCE12
#%__subst "s|/cgi-bin/|/ox/|" opt/html/RU/logout.htm
%{__sed} -i -e "s|/cgi-bin/|/ox/|" opt/html/RU/logout.htm
%__cp -pr opt/html/* %{buildroot}%_datadir/%name/groupware/data/templates/
%__cp -pr opt/locales/* %{buildroot}%_sysconfdir/%name/groupware/locales/
%__rm -rf opt
%__tar xjf %SOURCE13
%__cp -pr opt/html/* %{buildroot}%_datadir/%name/webmail/data/templates/
%__cp -pr opt/locales/* %{buildroot}%_sysconfdir/%name/webmail/locales/

# top icons for RU locale
%__mkdir_p %{buildroot}%_datadir/%name/htdocs/cfintranet/images/top/RU
%__cp ox_zenith_iconset/top/* %{buildroot}%_datadir/%name/htdocs/cfintranet/images/top/RU/

%pre server
%_sbindir/groupadd -r -f ox >/dev/null 2>&1 ||:
%_sbindir/useradd -r -g ox -c "open-xchange server" -d %_localstatedir/%name -s /sbin/nologin -n ox \
	>/dev/null 2>&1 ||:

%post server
chkconfig --add %{name}

%postun server
if [ $1 = 0 ] ; then
	userdel ox
	groupdel ox
fi

%preun server
if [ "$1" = 0 ] ; then
	chkconfig --del %{name}
fi

%post webapp-tomcat4
/sbin/service tomcat4 condrestart

%postun webapp-tomcat4
/sbin/service tomcat4 condrestart

%post webapp-tomcat5
/sbin/service tomcat5 condrestart

%postun webapp-tomcat5
/sbin/service tomcat5 condrestart

%post apache
/sbin/service httpd condrestart

%preun apache
if [ $1 = 0 ]; then
	/sbin/service httpd condrestart
fi

%post apache2
/sbin/service httpd condrestart

%preun apache2
if [ $1 = 0 ]; then
	/sbin/service httpd condrestart
fi

%files
%defattr(-,root,root)
%doc AUTHORS CHANGES COPYING ChangeLog INSTALL NEWS README QUICK-START.ALT
%_javadir/%name
%if %{with_ssl}
%_libdir/%name
%endif

%files server
%defattr(-,root,root)
%attr(0755,root,root) %_sysconfdir/rc.d/init.d/%{name}-*
%_sbindir/*
%_datadir/%name
%dir %attr(0770,root,ox) %_logdir/%name
%attr(0660,root,ox) %_logdir/%name/*
%attr(0775,root,ox) %_var/run/%name
%defattr(640,root,ox,751)
%dir %_sysconfdir/%name
%dir %_sysconfdir/%name/groupware
%dir %_sysconfdir/%name/webmail
%dir %_sysconfdir/%name/umin
%_sysconfdir/%name/webmail/locales
#%_sysconfdir/%name/groupware/CERT
%_sysconfdir/%name/groupware/METADB
%_sysconfdir/%name/groupware/locales
%_sysconfdir/%name/groupware/calendar
%_sysconfdir/%name/groupware/currencyformat
%_sysconfdir/%name/groupware/dateformat
%_sysconfdir/%name/groupware/external.conf
%_sysconfdir/%name/groupware/forum
%_sysconfdir/%name/groupware/intranet.conf
%_sysconfdir/%name/groupware/ldap.properties
%_sysconfdir/%name/groupware/nasi.conf
%_sysconfdir/%name/groupware/ldap.conf
%config(noreplace) %_sysconfdir/%name/groupware/server.conf
%_sysconfdir/%name/groupware/system.properties
%_sysconfdir/%name/groupware/tasks
%attr(640,ox,apache) %_sysconfdir/%name/umin/*.ox
%attr(640,ox,apache) %_sysconfdir/%name/umin/oxusermin.properties
%attr(640,ox,apache) %_sysconfdir/%name/umin/oxusermin_*
%_sysconfdir/%name/webmail/*.cfg
%_sysconfdir/%name/webmail/*.properties
%_sysconfdir/%name/webmail/ldap.conf
%config(noreplace) %_sysconfdir/%name/webmail/server.conf
%_sysconfdir/%name/webmail/nasi.conf
%attr(640,ox,apache) %config(noreplace) %_sysconfdir/%name/umin/oxuserminconfig.properties
%config(noreplace) %_sysconfdir/%name/admintools.conf
%defattr(660,root,ox,770)
%_localstatedir/%name

%files webapp-tomcat4
%defattr(-,root,root)
%_var/lib/tomcat4/webapps/servlet
%_var/lib/tomcat4/webapps/umin
%_var/lib/tomcat4/webapps/%name-servlet.xml
%_var/lib/tomcat4/webapps/%name-umin.xml

%files webapp-tomcat5
%defattr(-,root,root)
%_var/lib/tomcat5/webapps/servlet
%_var/lib/tomcat5/webapps/umin
%_sysconfdir/tomcat5/Catalina/localhost/*

%files apache
%defattr(-,root,root)
%config(noreplace) %_sysconfdir/httpd/conf/*

%files apache2
%defattr(-,root,root)
%config(noreplace) %_sysconfdir/httpd/conf.d/*

%files javadoc
%defattr(-,root,root)
%_javadocdir/%name

%changelog
* Fri Oct  7 2005 Peter Hanecak <hanecak@megaloman.sk> 0.8.0.4-1
- adapted to Doors Linux
- update to 0.8.0-4

* Tue Jun 14 2005 Vladimir Lettiev <crux@altlinux.ru> 0.8.0-alt1.3
- 0.8.0-3
- updated russian translation

* Mon May 16 2005 Vladimir Lettiev <crux@altlinux.ru> 0.8.0-alt1.2
- 0.8.0-2
- updated russian groupware translation, added webmail translation
  (Alex <exilit at nm.ru>

* Sat May 07 2005 Vladimir Lettiev <crux@altlinux.ru> 0.8.0-alt1.1
- 0.8.0-1
- added russian translation for groupware ( thanx 2 Alex <exilit at nm.ru> )

* Wed Apr 27 2005 Vladimir Lettiev <crux@altlinux.ru> 0.8.0-alt1
- 0.8.0
- added support for apache2 and tomcat4
- use postgresql74-jdbc

* Thu Apr 14 2005 Vladimir Lettiev <crux@altlinux.ru> 0.8.0-alt0.1.RC1
- Initial release for ALT Linux Sisyphus


